//****************************************************************************
//
// Copyright (c) 2000-2014 Broadcom Corporation
//
// This program is the proprietary software of Broadcom Corporation and/or
// its licensors, and may only be used, duplicated, modified or distributed
// pursuant to the terms and conditions of a separate, written license
// agreement executed between you and Broadcom (an "Authorized License").
// Except as set forth in an Authorized License, Broadcom grants no license
// (express or implied), right to use, or waiver of any kind with respect to
// the Software, and Broadcom expressly reserves all rights in and to the
// Software and all intellectual property rights therein.  IF YOU HAVE NO
// AUTHORIZED LICENSE, THEN YOU HAVE NO RIGHT TO USE THIS SOFTWARE IN ANY WAY,
// AND SHOULD IMMEDIATELY NOTIFY BROADCOM AND DISCONTINUE ALL USE OF THE
// SOFTWARE.
//
// Except as expressly set forth in the Authorized License,
//
// 1.     This program, including its structure, sequence and organization,
// constitutes the valuable trade secrets of Broadcom, and you shall use all
// reasonable efforts to protect the confidentiality thereof, and to use this
// information only in connection with your use of Broadcom integrated circuit
// products.
//
// 2.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, THE SOFTWARE IS PROVIDED
// "AS IS" AND WITH ALL FAULTS AND BROADCOM MAKES NO PROMISES, REPRESENTATIONS
// OR WARRANTIES, EITHER EXPRESS, IMPLIED, STATUTORY, OR OTHERWISE, WITH
// RESPECT TO THE SOFTWARE.  BROADCOM SPECIFICALLY DISCLAIMS ANY AND ALL
// IMPLIED WARRANTIES OF TITLE, MERCHANTABILITY, NONINFRINGEMENT, FITNESS FOR
// A PARTICULAR PURPOSE, LACK OF VIRUSES, ACCURACY OR COMPLETENESS, QUIET
// ENJOYMENT, QUIET POSSESSION OR CORRESPONDENCE TO DESCRIPTION. YOU ASSUME
// THE ENTIRE RISK ARISING OUT OF USE OR PERFORMANCE OF THE SOFTWARE.
//
// 3.     TO THE MAXIMUM EXTENT PERMITTED BY LAW, IN NO EVENT SHALL BROADCOM
// OR ITS LICENSORS BE LIABLE FOR (i) CONSEQUENTIAL, INCIDENTAL, SPECIAL,
// INDIRECT, OR EXEMPLARY DAMAGES WHATSOEVER ARISING OUT OF OR IN ANY WAY
// RELATING TO YOUR USE OF OR INABILITY TO USE THE SOFTWARE EVEN IF BROADCOM
// HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES; OR (ii) ANY AMOUNT IN
// EXCESS OF THE AMOUNT ACTUALLY PAID FOR THE SOFTWARE ITSELF OR U.S. $1,
// WHICHEVER IS GREATER. THESE LIMITATIONS SHALL APPLY NOTWITHSTANDING ANY
// FAILURE OF ESSENTIAL PURPOSE OF ANY LIMITED REMEDY.
//
//****************************************************************************
//
/*
** Author: Sean Dunlap
*/

#include "includes.h"
#include <string.h>

char * __progname = "OpenSSH";


void syslog (int __pri, const char *fmt, ...) 
{
    //if ( __pri <= trace_level )    //check for permission
    {
        va_list args;
      
        va_start( args, fmt );
        vfprintf( stdout, fmt, args );
        va_end( args );
      
        fflush( stdout );
    }
}

void openlog (__const char *__ident, int __option, int __facility)
{

}

void closelog (void)
{

}

/*
 * Close all file descriptors greater than or equal to lowfd.
 */
void
closefrom(int lowfd)
{
}

int ECOS_execv( char * name, char ** av )
{
    printf("WARNING!!!  Inside ECOS_execv!\n");
    return 0;
}

pid_t waitpid (pid_t pid, int * arg2, int arg3)
{
    printf("WARNING!!!  Inside waitpid!\n");
    return 0;
}

int chmod (const char *__path, mode_t __mode )
{
    return 0;
}

int chown (const char *__path, uid_t __owner, gid_t __group )
{
    return 0;
}

int chroot (const char *__path )
{
    return 0;
}

#if 0
pid_t fork(void )
{
    // In the original process (the parent) the return value of fork 
    // will be the process ID of the child. In the new child process 
    // the return value of fork will be 0. 
    return 0;   
};
#endif

/*
 * NB. duplicate __progname in case it is an alias for argv[0]
 * Otherwise it may get clobbered by setproctitle()
 */
char *ssh_get_progname(char *argv0)
{
    return "This is my progname";
}

//DAEMON(3)                BSD Library Functions Manual                DAEMON(3)
//
//DESCRIPTION
//     The daemon() function is for programs wishing to detach themselves from
//     the controlling terminal and run in the background as system daemons.
//
//     Unless the argument nochdir is non-zero, daemon() changes the current
//     working directory to the root (/).
//
//     Unless the argument noclose is non-zero, daemon() will redirect standard
//     input, standard output, and standard error to /dev/null.
//
//RETURN VALUES
//     The daemon() function returns the value 0 if successful; otherwise the
//     value -1 is returned and the global variable errno is set to indicate the
//     error.
// 
int daemon(int nochdir, int noclose)
{
    return 0;
}


// this is a replacement for unix signals
void ECOS_signal( int event, void (* handler_function)(int event)  )
{
    // sometimes, the signal handlers themselves send themselves the same signal. 
    // I don't understand why this would be, but we need to detect it to prevent
    // endless loop.  sighup_handler() is an example of this. 
    static void (*prev_handler_function)(int event) = NULL;
    
    if( handler_function != prev_handler_function )
    {
        prev_handler_function = handler_function;

        // invoke the handler function
        handler_function( event );
    }

    prev_handler_function = NULL;
}


int ECOS_chdir(const char *path)
{
    return 0;
}

int ECOS_socketpair(int af, int type, int protocol, int sv[2])
{
    sv[0] = socket(af, type, protocol);
    sv[1] = socket(af, type, protocol);
}


/* removed strlcat() from this file and added it to our distribution here:
 * rbb_cm_src\CableModemBsp\bsp_common\common_src\strlcpy.c
 * rbb_cm_src\CableModemBsp\bsp_common\common_src\strlcat.c
 * rbb_cm_ecos\ecos-src\ecos-2.0\packages\language\c\libc\string\v2_0\include\string.h  
 * on 9/24/13 by gtrimble
 */

typedef void (*mysig_t)(int);

void
mysignal(int sig, mysig_t act)
{
    //printf("inside mysignal().  Not implemented yet.\n");
}


void ecos_fatal(const char *fmt, ...)
{
    char buf[1024];
    va_list args;
    va_start(args, fmt);

    printf("FATAL ERROR in OpenSSH: ");
    vsnprintf(buf, sizeof(buf), fmt, args);
    va_end(args);

    printf("%s\n", buf);

}
